////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// F A R M     -  Flair advanced rendering module
//
// Copyright European Organization for Nuclear Research( CERN )
// All rights reserved
//
// Authors: Christian.Theis@cern.ch
//			    Vasilis.Vlachoudis@cern.ch
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "baseintegrator.h"
#include "geometry/voxel.h"
#include "viewer/viewer.h"
#include "farm.h"

CBaseIntegrator::CBaseIntegrator() : m_pRenderer( nullptr), m_pVisLayer(nullptr), m_pVoxelLayer(nullptr), m_pGeometry(nullptr), m_NrOfMCSamples( 32 ),
m_MinSamplesBeforeRussianRoulette( 4 ), m_RussianRouletteSurvival( 0.5 ), m_NrOfVolLightMCSamples( 32 ), m_NrOfIndirectLightingSamples( 32 ),
m_RenderMode( cSpeed ), m_RenderQuality(0), m_bInitialized(false)
{
}

CBaseIntegrator::~CBaseIntegrator( void )
{
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CBaseIntegrator::Init( CFARM* pRenderer, D3Layer* pVisLayer, VVoxel* pVoxelLayer, Geometry* pGeometry )

// basic initialization
// [4/27/2020 theis]
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
{
	m_pRenderer		= pRenderer;
	m_pVisLayer		= pVisLayer;
	m_pVoxelLayer = pVoxelLayer;
	m_pGeometry		= pGeometry;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CBaseIntegrator::RussianRoulette( float SurvivalProbability )

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
{
	float Rnd = static_cast<float>( m_Random.real() );

	if( Rnd < std::max( 0.f, std::min( 1.f, SurvivalProbability ) ) )
		return true;

	return false;
}
// vim:ts=2
