/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	04-Feb-2010
 */

#include "cbody.h"
#include "engine.h"

/** return name of body */
const std::string& CBody::name() const
{
	return gbody->name();
} // name

/** return name of body */
const char* CBody::cname() const
{
	return gbody->cname();
} // cname

/** Inside2D version before use please call incBodyCheckId() */
bool CBody::inside2D(const double x, const double y, const double z,
		     const double u, const double v, const double w)
{
	if (vbody->nC==0 && vbody->location!=GBody::Location::OVERLAP)
		// FIXME
		return (bool)vbody->location;
	if (*gCheckId != _checkId) {
		checkInside = gbody->inside(x,y,z, u,v,w, vbody->acc);
		checked();
	}
	return checkInside;
} // inside2D

