/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	08-Jul-2016
 */

#ifndef __GEOMETRY_VERTEX_H
#define __GEOMETRY_VERTEX_H

//#include <vector>

#include "tool/array.h"
#include "math/point.h"

/* ============================= Vertex ============================== */
/** A 3D Vertex/Point of meshes
 */
class Vertex : public Point {
private:
public:
	// Constructor
	Vertex(const double ax=0.0, const double ay=0.0, const double az=0.0)
		: Point(ax, ay, az) {}

	// Copy constructor
	Vertex(const Vertex&) = default;
	Vertex& operator=(const Vertex&) = default;
	Vertex(const Point& p) : Point(p) {}

	// ??? why I cannot use the Vector::compare() directly????
static int	compare(Vertex* const& a, Vertex* const& b) {
			return Vector::compare(a, b);
		}
}; // Vertex

typedef Array<Vertex*>	VertexArray;
//typedef std::vector<Vertex*>	VertexVector;
typedef int (*VertexFunc)(Vertex*,void*);

#endif
