/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 */

#ifndef __VIEWER_LATTICE_LAYER_H
#define __VIEWER_LATTICE_LAYER_H

#include "layer.h"
#include "geometry/geometry.h"

class Painter;

/* ============================== LatticeLayer ============================== */
class LatticeLayer : public Layer {
public:
	int	level;		/** lattice level		*/
	dword	hashColor;	/** lattice hash color		*/

public:
	LatticeLayer(const Geometry& g, GeometryKernel& k, GeometryViewer& v) :
			Layer(g, k, v),
			level(224) {}

	void	makeHashColor() { hashColor = Color32::darker(geometry.latticeColor, level); }

	void	draw(Painter& painter);
}; // LatticeLayer

#endif
